// -------------------------------------------------------------------------------------
// 
// TaktStrasse.CS                                                 Ulrich Mller 14.01.05
//                                                                PCS1700   C# Final SP2
// Trainingsmodell 51 664 : Taktstrae, MultiThread-Version
// Die einzelnen Bearbeitungsstationen laufen jeweils in eigenen Threads simultan,
// die Bearbeitungsschritte werden gleichzeitig gestartet.
// mit FishFa30.DLL auf Basis von umFish30.DLL
// Einsatz von Intelligent Interface mit Extension Module 
// oder        ROBO Interface mit I/O-Extension beides im Online-Mode
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using FishFa30;

namespace TaktStrasse
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.Label lblAblage;
		private System.Windows.Forms.Label lblBohren;
		private System.Windows.Forms.Label lblPutzen;
		private System.Windows.Forms.Label lblZufuhr;
		private System.ComponentModel.Container components = null;

		// --- FishFace, Threads ------------------------------

		private FishFace ft = new FishFace(false, true, 0);
		private Thread   KontrollThread;
		private Thread   ZufuhrThread;
		private Thread   PutzenThread;
		private Thread   BohrenThread;
		private Thread   AblageThread;

		private AutoResetEvent ZufuhrReady;
		private AutoResetEvent PutzenReady;
		private AutoResetEvent BohrenReady;
		private AutoResetEvent AblageReady;

		private ManualResetEvent AllReady;

		private bool Abschalten;

		// --- Interface-Belegung --------------------------------------

		const int zfBandMotor = 1, zfPhotoEin = 1, zfPhotoAus = 2,
			      ptBandMotor = 2, ptSchieberMotor = 3, ptRuckTaster = 3, ptVorTaster = 4,
			      ptPutzMotor = 4, ptPhotoEin  = 5,
			      bhBandMotor = 5, bhBohrMotor = 6, bhPhotoEin = 9,
			      agBandMotor = 7, agSchieberMotor = 8, agRuckTaster = 10, 
			      agVorTaster = 11, agPhotoEin = 12;
		const int ftiEin = 1, ftiAus = 0, ftiLinks = 1, ftiRechts = 2;

		private System.Windows.Forms.Label lblStatus;

		public frmMain()
		{
			InitializeComponent();
			cboPortName.SelectedIndex = 2;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblAblage = new System.Windows.Forms.Label();
			this.lblBohren = new System.Windows.Forms.Label();
			this.lblPutzen = new System.Windows.Forms.Label();
			this.lblZufuhr = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(688, 32);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(24, 16);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(528, 400);
			this.pictureBox2.TabIndex = 1;
			this.pictureBox2.TabStop = false;
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(616, 376);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(112, 32);
			this.cmdAction.TabIndex = 2;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(616, 336);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(112, 32);
			this.cmdEnde.TabIndex = 3;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cboPortName
			// 
			this.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPortName.Items.AddRange(new object[] {
															 "LST",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(616, 288);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(112, 21);
			this.cboPortName.TabIndex = 4;
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(576, 248);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(152, 16);
			this.lblStatus.TabIndex = 5;
			this.lblStatus.Text = "START / ENDE";
			// 
			// lblAblage
			// 
			this.lblAblage.Location = new System.Drawing.Point(576, 152);
			this.lblAblage.Name = "lblAblage";
			this.lblAblage.Size = new System.Drawing.Size(152, 16);
			this.lblAblage.TabIndex = 6;
			this.lblAblage.Text = "Ablage in Ruhe";
			// 
			// lblBohren
			// 
			this.lblBohren.Location = new System.Drawing.Point(576, 176);
			this.lblBohren.Name = "lblBohren";
			this.lblBohren.Size = new System.Drawing.Size(152, 16);
			this.lblBohren.TabIndex = 7;
			this.lblBohren.Text = "Bohren in Ruhe";
			// 
			// lblPutzen
			// 
			this.lblPutzen.Location = new System.Drawing.Point(576, 200);
			this.lblPutzen.Name = "lblPutzen";
			this.lblPutzen.Size = new System.Drawing.Size(152, 16);
			this.lblPutzen.TabIndex = 8;
			this.lblPutzen.Text = "Putzen in Ruhe";
			// 
			// lblZufuhr
			// 
			this.lblZufuhr.Location = new System.Drawing.Point(576, 224);
			this.lblZufuhr.Name = "lblZufuhr";
			this.lblZufuhr.Size = new System.Drawing.Size(152, 16);
			this.lblZufuhr.TabIndex = 9;
			this.lblZufuhr.Text = "Zufuhr in Ruhe";
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(744, 445);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblZufuhr,
																		  this.lblPutzen,
																		  this.lblBohren,
																		  this.lblAblage,
																		  this.lblStatus,
																		  this.cboPortName,
																		  this.cmdEnde,
																		  this.cmdAction,
																		  this.pictureBox2,
																		  this.pictureBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "Trainingsmodell 51 664 : Taktstrae";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}
		// --- Schlieen der Form ablehnen, wenn das Modell noch luft ----
		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(cmdEnde.Text == "&HALT") e.Cancel = true;
		}
		// --- Beenden des Modellbetriebs bei Button HALT
		//             des Programms      bei Button ENDE
		private void cmdEnde_Click(object sender, System.EventArgs e) {
			if(cmdEnde.Text == "&HALT") {
				Abschalten = true; 
				ft.NotHalt = true;
				// --- Zuendefhren der laufenden Threads -----
				lblStatus.Text = "Taktstrae fhrt runter";
				lblStatus.BackColor = Color.Yellow;
				Application.DoEvents();

				// --- Auslaufphase ----------------------------
				lblStatus.Text = "TaktStrae in Auslaufphase";
				ft.CloseInterface();
				lblStatus.Text = "TaktStrae abgeschaltet";
				lblStatus.BackColor = Color.Gray;
				cmdEnde.Text = "&ENDE";
				cmdAction.Enabled = true;
			}
			else this.Close();
		}

		// --- cmdAction_Click : Steuern des Modellbetriebs ---------------------
		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {

				ft.OpenInterface(cboPortName.SelectedIndex);

				// --- Threads instanzieren ------------------------------
				KontrollThread = new Thread(new ThreadStart(KontrollExecute));
				ZufuhrThread   = new Thread(new ThreadStart(ZufuhrExecute));
				PutzenThread   = new Thread(new ThreadStart(PutzenExecute));
				BohrenThread   = new Thread(new ThreadStart(BohrenExecute));
				AblageThread   = new Thread(new ThreadStart(AblageExecute));

				ZufuhrReady = new AutoResetEvent(false);
				PutzenReady = new AutoResetEvent(false);
				BohrenReady = new AutoResetEvent(false);
				AblageReady = new AutoResetEvent(false);

				AllReady = new ManualResetEvent(true);

				// --- Ready-Meldung ------------------
				cmdAction.Enabled = false;
				cmdEnde.Text      = "&HALT";
				lblStatus.Text    = "TaktStrae gestartet";
				lblStatus.BackColor = Color.Yellow;
				cmdEnde.Focus();

				// --- Anlaufphase --------------------------------------
				lblStatus.Text = "TaktStrae in Anlaufphase";
				Init();
				Zufuhr();
				Putzen();
				Bohren();
				Zufuhr();
				Putzen();
				Zufuhr();

				// --- Thread-Start -------------------------------------
				ZufuhrThread.Start();
				PutzenThread.Start();
				BohrenThread.Start();
				AblageThread.Start();
				Abschalten = false;
				lblStatus.Text = "TaktStrae in Betrieb";
				lblStatus.BackColor = Color.Green;
				Application.DoEvents();
				Thread.Sleep(200);
				KontrollThread.Start();
			}
			catch (FishFaceException eft){
				lblStatus.Text = eft.Message;
				lblStatus.BackColor = Color.Red;
				return;
			}
		}

		// --- Thread Routinen -----------------------------------------------
		private void KontrollExecute() {
			// --- Thread-Steuerung ---------------------------------
			while(!Abschalten) {
				AllReady.Reset();
				ZufuhrReady.WaitOne();
				PutzenReady.WaitOne();
				BohrenReady.WaitOne();
				AblageReady.WaitOne();
				AllReady.Set();
				Thread.Sleep(200);
			}
		}
		private void ZufuhrExecute() {
			do {
				AllReady.WaitOne();
				Thread.Sleep(5000);  // --- Schieber Rck abwarten
				Zufuhr();
				ZufuhrReady.Set();
			} while(!Abschalten);
		}
		private void PutzenExecute() {
			do {
				AllReady.WaitOne();
				Putzen();
				PutzenReady.Set();
			} while(!Abschalten);
		}
		private void BohrenExecute() {
			do {
				AllReady.WaitOne();
				Bohren();
				BohrenReady.Set();
			} while(!Abschalten);
		}
		private void AblageExecute() {
			do {
				AllReady.WaitOne();
				Ablage();
				AblageReady.Set();
			} while(!Abschalten);
		}

		// --- Routinen fr die Bearbeitungsstationen ------------------------
		private void Zufuhr() {
			lblZufuhr.Text = "Zufuhr gestartet";
			lblZufuhr.BackColor = Color.Green;
			ft.WaitForLow(zfPhotoEin);
			ft.SetMotor(zfBandMotor, ftiLinks);
			ft.WaitForLow(zfPhotoAus);
			ft.WaitForTime(1500);
			ft.SetMotor(zfBandMotor, ftiAus);
			lblZufuhr.Text = "Zufuhr beendet";
			lblZufuhr.BackColor = Color.Gray;
		}
		private void Putzen() {
			lblPutzen.Text = "Putzen gestartet";
			lblPutzen.BackColor = Color.Green;
			ft.SetMotor(ptSchieberMotor, ftiRechts);
			ft.SetMotor(ptBandMotor, ftiLinks);
			ft.WaitForInput(ptVorTaster);
			ft.SetMotor(ptSchieberMotor, ftiAus);
			ft.SetMotor(ptPutzMotor, ftiRechts);
			ft.WaitForLow(ptPhotoEin);
			ft.SetMotor(ptBandMotor, ftiAus);
			ft.SetMotor(ptSchieberMotor, ftiLinks);
			ft.WaitForInput(ptRuckTaster);
			ft.SetMotor(ptSchieberMotor, ftiAus);
			ft.WaitForTime(5000);
			ft.SetMotor(ptPutzMotor, ftiAus);
			ft.SetMotor(ptBandMotor, ftiLinks);
			ft.WaitForTime(2000);
			ft.SetMotor(ptBandMotor, ftiAus);
			lblPutzen.Text = "Putzen beendet";
			lblPutzen.BackColor = Color.Gray;
		}
		private void Bohren() {
			lblBohren.Text = "Bohren gestartet";
			lblBohren.BackColor = Color.Green;
			ft.SetMotor(bhBandMotor, ftiLinks);
			ft.WaitForLow(bhPhotoEin);
			ft.SetMotor(bhBandMotor, ftiAus);
			ft.SetMotor(bhBohrMotor, ftiRechts);
			ft.WaitForTime(3000);
			ft.SetMotor(bhBohrMotor, ftiAus);
			ft.SetMotor(bhBandMotor, ftiLinks);
			ft.WaitForTime(2000);
			ft.SetMotor(bhBandMotor, ftiAus);
			lblBohren.Text = "Bohren beendet";
			lblBohren.BackColor = Color.Gray;
		}
		private void Ablage() {
			lblAblage.Text = "Ablage gestartet";
			lblAblage.BackColor = Color.Green;
			ft.SetMotor(agSchieberMotor, ftiRechts);
			ft.SetMotor(agBandMotor, ftiLinks);
			ft.WaitForInput(agVorTaster);
			ft.SetMotor(agSchieberMotor, ftiAus);
			ft.WaitForLow(agPhotoEin);
			ft.WaitForTime(1000);
			ft.SetMotor(agBandMotor, ftiAus);
			ft.SetMotor(agSchieberMotor, ftiLinks);
			ft.WaitForInput(agRuckTaster);
			ft.SetMotor(agSchieberMotor, ftiAus);
			lblAblage.Text = "Ablage beendet";
			lblAblage.BackColor = Color.Gray;
		}
		private void Init() {
			ft.SetMotor(ptSchieberMotor, ftiLinks);
			ft.WaitForInput(ptRuckTaster);
			ft.SetMotor(ptSchieberMotor, ftiAus);
			ft.SetMotor(agSchieberMotor, ftiLinks);
			ft.WaitForInput(agRuckTaster);
			ft.SetMotor(agSchieberMotor, ftiAus);
		}

	}
}
